#include "cbox11.h"

main()
{
	/*[The lengths of arrays has been increased by one, first 
					one is not used ]*/
	int Code[101],Dim,NN;
	float X[52], Y[52], Xm[51], Ym[51],Xi[21], Yi[21],Bc[101],F[101];
	float G[101][101],H[101][101],D,stress[61],displ[41];
       
	Dim = 100;	/*[Dim = Max dimension of the system AX = F]*/

	/*[ Read Data ]*/
	
	Input11(Xi,Yi,X,Y,Code,Bc);
	
	
	/*[ Compute matrices G and H and form the system AX = F  ]*/
	
	Sys11(X,Y,Xm,Ym,G,H,Bc,F,Code,Dim);
	
	/*[Solve the system AX = F ]*/
	
	NN = 2*N;
	
	Solve(G,F,&D,NN,Dim);
	
	/*[ Compute stress and displacement at interior points ]*/
	
	Inter11(Bc,F,Code,Xi,Yi,X,Y,stress,displ);
	
	/*[Output solution at boundary nodes and interior Points ]*/
	
	Out11(Xm,Ym,Bc,F,Xi,Yi,stress,displ);
}
