#include "cbox1.h"
void Inter1(Bc,F,Code,Xi,Yi,X,Y,u,q1,q2)
	float Bc[101],F[101],Xi[21],Yi[21],X[102],Y[102];
	float u[21],q1[21],q2[21];
	int Code[101];
{
	float temp,A,B,qx,qy,ux,uy;
	int i,j,k,m;
/*[A and B are 2-D arrays; Quad1 takes these arrays when called.
The arrays Bc and F are rearranged to store all the values of u in Bc and all the values of q in F. ]*/
	for(i=1;i<=N;i++)
	{
		if(Code[i] > 0)
		{
			temp = Bc[i];
			Bc[i] = F[i];
			F[i] = temp;
		}
	 }
 /*[ Compute u and q at interior Points ]*/
 
 	if(L)
	{
		for(k=1;k<=L;k++)
		{
			u[k]   = 0.0;
			q1[k] = 0.0;
			q2[k] = 0.0;
			for(j=1;j<=N;j++)
			{
			  m = j + 1;
Quad1(Xi[k],Yi[k],X[j],Y[j],X[m],Y[m],&A,&B,&qx,&qy,&ux,&uy,1);
			u[k]   += F[j]*B - Bc[j]*A;
			q1[k] += F[j]*ux-Bc[j]*qx; 
			q2[k] += F[j]*uy-Bc[j]*qy;
			}
			u[k]   /= 2.0 * pi;
			q1[k] /= 2.0 * pi;
			q2[k] /= 2.0 * pi;
	       }
	  }
  }
