#include "cbox11.h"

void Out11(Xm,Ym,Bc,F,Xi,Yi,stress,displ)
float Xm[51],Ym[51],Bc[101],F[101],Xi[21],Yi[21],stress[61],displ[41];
{
	
	FILE *outfile;
	int i,j,k;
	
	outfile = fopen(outname,"a");
		
	fprintf(outfile,"\nResults:\n\n Boundary Nodes\n\n");
	fprintf(outfile,"	   X		  Y		     Displ X	Displ Y  Traction X  Traction Y\n");
	for(i=1;i<=N;i++)
		fprintf(outfile,"(%10.4f, %10.4f) %10.4f %10.4f %10.4f %10.4f\n",
						Xm[i],Ym[i],Bc[2*i-1],Bc[2*i],F[2*i-1],F[2*i]);
		
	if(L)
	{	
		fprintf(outfile,"\nInterior point displacements\n\n");
		fprintf(outfile,"	   Xi		  Yi		 Displacement X		Displacement Y\n");
		for(k=1;k<=L;k++)
			fprintf(outfile,"(%10.4f,%10.4f) \t %10.4f \t %10.4f\n",
				Xi[k],Yi[k],displ[2*k-1],displ[2*k]); 
		
		fprintf(outfile,"\nInterior point stresses\n\n");
		fprintf(outfile,"	   Xi         Yi        Sigma X           Tau XY       Sigma Y\n");
	
		for(k=1;k<=L;k++)
			fprintf(outfile,"(%10.4f,%10.4f)\t %10.4f \t  %10.4f \t%10.4f\n",
					Xi[k],Yi[k],stress[3*k-2],stress[3*k-1],stress[3*k]);
					
	}
	fclose(outfile);
}
