# include "cbox5.h"

void Inter5(Bc,F,Code,Xi,Yi,X,Y,u,q1,q2)

float Bc[101],F[101],Xi[21],Yi[21];
float X[102],Y[102],u[21],q1[21],q2[21];
int Code[101];
{
	int i,j,k,lk,kk,found;
	float A,B,qx,qy,ux,uy,temp;
	
	found = 0; 	/*[	Initialization ]*/
	/*[ Rearrange the Bc and F arrays to store all values of the
		potential in Bc and all potential derivatives in F ]*/
		
	
	for(i=1;i<=N;i++)
	{
		if(Code[i] > 0)
		{
			temp = Bc[i];
			Bc[i] = F[i];
			F[i] = temp;
		}
	}
	/*[ Compute the potential and fluxes at the interior points ]*/
	
	if(L)
	{
		for(k=1;k<=L;k++)
		{
			u[k] = 0.0;
			q1[k] = 0.0;
			q2[k] = 0.0;
			for(j=1;j<=N;j++)
			{
				if((M-1) > 0)
				{
					if(!(j-Last[1]))
						kk = 1;
					else
						{
							found = 0;
							for(lk=2;lk<=M;lk++)
							{
								if(!(j-Last[lk]))
								{
									kk = Last[lk-1] + 1;
									found = 1;
									break;
								}
							}
							if(!found)
								kk = j + 1;								
						}
				}
				else
					kk = j + 1;
				Quad5(Xi[k],Yi[k],X[j],Y[j],X[kk],Y[kk],
						&A,&B,&qx,&qy,&ux,&uy,1); 
				u[k]   += F[j]*B - Bc[j]*A;
				q1[k] += F[j]*ux - Bc[j]* qx;
				q2[k] += F[j]*uy - Bc[j]* qy;
			}
			u[k]   /= 2 * pi;
			q1[k] /= 2 * pi;
			q2[k] /= 2 * pi;
		}
	}
}
